/* This software is licensed by the MIT License, see LICENSE file */
/*                                Copyright © 2022 Gregory Lirent */

#include "include.h"

int libcdsb_array_find_pointer(arr_t* x, const   void* v, void* _, array_access_callback cb, bool r, bool cut) { return libcdsb_array_find(x, &v, vtypeof(&v), _, cb, r, cut); }
int libcdsb_array_find_cstring(arr_t* x, const   char* v, void* _, array_access_callback cb, bool r, bool cut) { return libcdsb_array_find(x, &v, vtypeof(&v), _, cb, r, cut); }
int libcdsb_array_find_string (arr_t* x, const  str_t* v, void* _, array_access_callback cb, bool r, bool cut) { return libcdsb_array_find(x,  v, vtypeof( v), _, cb, r, cut); }
int libcdsb_array_find_array  (arr_t* x, const  arr_t* v, void* _, array_access_callback cb, bool r, bool cut) { return libcdsb_array_find(x,  v, vtypeof( v), _, cb, r, cut); }
int libcdsb_array_find_list   (arr_t* x, const list_t* v, void* _, array_access_callback cb, bool r, bool cut) { return libcdsb_array_find(x,  v, vtypeof( v), _, cb, r, cut); }
int libcdsb_array_find_map    (arr_t* x, const  map_t* v, void* _, array_access_callback cb, bool r, bool cut) { return libcdsb_array_find(x,  v, vtypeof( v), _, cb, r, cut); }
int libcdsb_array_find_vset   (arr_t* x, const  set_t* v, void* _, array_access_callback cb, bool r, bool cut) { return libcdsb_array_find(x,  v, vtypeof( v), _, cb, r, cut); }
int libcdsb_array_find_dict   (arr_t* x, const dict_t* v, void* _, array_access_callback cb, bool r, bool cut) { return libcdsb_array_find(x,  v, vtypeof( v), _, cb, r, cut); }
int libcdsb_array_find_boolean(arr_t* x,          bool v, void* _, array_access_callback cb, bool r, bool cut) { return libcdsb_array_find(x, &v, vtypeof(&v), _, cb, r, cut); }
int libcdsb_array_find_int8   (arr_t* x,          s8_t v, void* _, array_access_callback cb, bool r, bool cut) { return libcdsb_array_find(x, &v, vtypeof(&v), _, cb, r, cut); }
int libcdsb_array_find_int16  (arr_t* x,         s16_t v, void* _, array_access_callback cb, bool r, bool cut) { return libcdsb_array_find(x, &v, vtypeof(&v), _, cb, r, cut); }
int libcdsb_array_find_int32  (arr_t* x,         s32_t v, void* _, array_access_callback cb, bool r, bool cut) { return libcdsb_array_find(x, &v, vtypeof(&v), _, cb, r, cut); }
int libcdsb_array_find_int64  (arr_t* x,         s64_t v, void* _, array_access_callback cb, bool r, bool cut) { return libcdsb_array_find(x, &v, vtypeof(&v), _, cb, r, cut); }
int libcdsb_array_find_uint8  (arr_t* x,          u8_t v, void* _, array_access_callback cb, bool r, bool cut) { return libcdsb_array_find(x, &v, vtypeof(&v), _, cb, r, cut); }
int libcdsb_array_find_uint16 (arr_t* x,         u16_t v, void* _, array_access_callback cb, bool r, bool cut) { return libcdsb_array_find(x, &v, vtypeof(&v), _, cb, r, cut); }
int libcdsb_array_find_uint32 (arr_t* x,         u32_t v, void* _, array_access_callback cb, bool r, bool cut) { return libcdsb_array_find(x, &v, vtypeof(&v), _, cb, r, cut); }
int libcdsb_array_find_uint64 (arr_t* x,         u64_t v, void* _, array_access_callback cb, bool r, bool cut) { return libcdsb_array_find(x, &v, vtypeof(&v), _, cb, r, cut); }
int libcdsb_array_find_float  (arr_t* x,          fl_t v, void* _, array_access_callback cb, bool r, bool cut) { return libcdsb_array_find(x, &v, vtypeof(&v), _, cb, r, cut); }
int libcdsb_array_find_double (arr_t* x,         dbl_t v, void* _, array_access_callback cb, bool r, bool cut) { return libcdsb_array_find(x, &v, vtypeof(&v), _, cb, r, cut); }
int libcdsb_array_find_ldouble(arr_t* x,        ldbl_t v, void* _, array_access_callback cb, bool r, bool cut) { return libcdsb_array_find(x, &v, vtypeof(&v), _, cb, r, cut); }

size_t libcdsb_array_count_pointer(const arr_t* x, const   void* v) { return libcdsb_array_count(x, &v, vtypeof(&v)); }
size_t libcdsb_array_count_cstring(const arr_t* x, const   char* v) { return libcdsb_array_count(x, &v, vtypeof(&v)); }
size_t libcdsb_array_count_string (const arr_t* x, const  str_t* v) { return libcdsb_array_count(x,  v, vtypeof( v)); }
size_t libcdsb_array_count_array  (const arr_t* x, const  arr_t* v) { return libcdsb_array_count(x,  v, vtypeof( v)); }
size_t libcdsb_array_count_list   (const arr_t* x, const list_t* v) { return libcdsb_array_count(x,  v, vtypeof( v)); }
size_t libcdsb_array_count_map    (const arr_t* x, const  map_t* v) { return libcdsb_array_count(x,  v, vtypeof( v)); }
size_t libcdsb_array_count_vset   (const arr_t* x, const  set_t* v) { return libcdsb_array_count(x,  v, vtypeof( v)); }
size_t libcdsb_array_count_dict   (const arr_t* x, const dict_t* v) { return libcdsb_array_count(x,  v, vtypeof( v)); }
size_t libcdsb_array_count_boolean(const arr_t* x,          bool v) { return libcdsb_array_count(x, &v, vtypeof(&v)); }
size_t libcdsb_array_count_int8   (const arr_t* x,          s8_t v) { return libcdsb_array_count(x, &v, vtypeof(&v)); }
size_t libcdsb_array_count_int16  (const arr_t* x,         s16_t v) { return libcdsb_array_count(x, &v, vtypeof(&v)); }
size_t libcdsb_array_count_int32  (const arr_t* x,         s32_t v) { return libcdsb_array_count(x, &v, vtypeof(&v)); }
size_t libcdsb_array_count_int64  (const arr_t* x,         s64_t v) { return libcdsb_array_count(x, &v, vtypeof(&v)); }
size_t libcdsb_array_count_uint8  (const arr_t* x,          u8_t v) { return libcdsb_array_count(x, &v, vtypeof(&v)); }
size_t libcdsb_array_count_uint16 (const arr_t* x,         u16_t v) { return libcdsb_array_count(x, &v, vtypeof(&v)); }
size_t libcdsb_array_count_uint32 (const arr_t* x,         u32_t v) { return libcdsb_array_count(x, &v, vtypeof(&v)); }
size_t libcdsb_array_count_uint64 (const arr_t* x,         u64_t v) { return libcdsb_array_count(x, &v, vtypeof(&v)); }
size_t libcdsb_array_count_float  (const arr_t* x,          fl_t v) { return libcdsb_array_count(x, &v, vtypeof(&v)); }
size_t libcdsb_array_count_double (const arr_t* x,         dbl_t v) { return libcdsb_array_count(x, &v, vtypeof(&v)); }
size_t libcdsb_array_count_ldouble(const arr_t* x,        ldbl_t v) { return libcdsb_array_count(x, &v, vtypeof(&v)); }

void libcdsb_array_push_pointer(arr_t* x, const   void* v) { libcdsb_array_push(x, &v, vtypeof(&v)); }
void libcdsb_array_push_cstring(arr_t* x, const   char* v) { libcdsb_array_push(x, &v, vtypeof(&v)); }
void libcdsb_array_push_string (arr_t* x, const  str_t* v) { libcdsb_array_push(x,  v, vtypeof( v)); }
void libcdsb_array_push_array  (arr_t* x, const  arr_t* v) { libcdsb_array_push(x,  v, vtypeof( v)); }
void libcdsb_array_push_list   (arr_t* x, const list_t* v) { libcdsb_array_push(x,  v, vtypeof( v)); }
void libcdsb_array_push_map    (arr_t* x, const  map_t* v) { libcdsb_array_push(x,  v, vtypeof( v)); }
void libcdsb_array_push_vset   (arr_t* x, const  set_t* v) { libcdsb_array_push(x,  v, vtypeof( v)); }
void libcdsb_array_push_dict   (arr_t* x, const dict_t* v) { libcdsb_array_push(x,  v, vtypeof( v)); }
void libcdsb_array_push_boolean(arr_t* x,          bool v) { libcdsb_array_push(x, &v, vtypeof(&v)); }
void libcdsb_array_push_int8   (arr_t* x,          s8_t v) { libcdsb_array_push(x, &v, vtypeof(&v)); }
void libcdsb_array_push_int16  (arr_t* x,         s16_t v) { libcdsb_array_push(x, &v, vtypeof(&v)); }
void libcdsb_array_push_int32  (arr_t* x,         s32_t v) { libcdsb_array_push(x, &v, vtypeof(&v)); }
void libcdsb_array_push_int64  (arr_t* x,         s64_t v) { libcdsb_array_push(x, &v, vtypeof(&v)); }
void libcdsb_array_push_uint8  (arr_t* x,          u8_t v) { libcdsb_array_push(x, &v, vtypeof(&v)); }
void libcdsb_array_push_uint16 (arr_t* x,         u16_t v) { libcdsb_array_push(x, &v, vtypeof(&v)); }
void libcdsb_array_push_uint32 (arr_t* x,         u32_t v) { libcdsb_array_push(x, &v, vtypeof(&v)); }
void libcdsb_array_push_uint64 (arr_t* x,         u64_t v) { libcdsb_array_push(x, &v, vtypeof(&v)); }
void libcdsb_array_push_float  (arr_t* x,          fl_t v) { libcdsb_array_push(x, &v, vtypeof(&v)); }
void libcdsb_array_push_double (arr_t* x,         dbl_t v) { libcdsb_array_push(x, &v, vtypeof(&v)); }
void libcdsb_array_push_ldouble(arr_t* x,        ldbl_t v) { libcdsb_array_push(x, &v, vtypeof(&v)); }
