/* This software is licensed by the MIT License, see LICENSE file */
/*                                Copyright © 2022 Gregory Lirent */

#include "include.h"

int libcdsb_list_find_pointer(list_t* x, const   void* v, void* _, list_access_callback cb, bool r, bool cut) { return libcdsb_list_find(x, &v, vtypeof(&v), _, cb, r, cut); }
int libcdsb_list_find_cstring(list_t* x, const   char* v, void* _, list_access_callback cb, bool r, bool cut) { return libcdsb_list_find(x, &v, vtypeof(&v), _, cb, r, cut); }
int libcdsb_list_find_string (list_t* x, const  str_t* v, void* _, list_access_callback cb, bool r, bool cut) { return libcdsb_list_find(x,  v, vtypeof( v), _, cb, r, cut); }
int libcdsb_list_find_array  (list_t* x, const  arr_t* v, void* _, list_access_callback cb, bool r, bool cut) { return libcdsb_list_find(x,  v, vtypeof( v), _, cb, r, cut); }
int libcdsb_list_find_list   (list_t* x, const list_t* v, void* _, list_access_callback cb, bool r, bool cut) { return libcdsb_list_find(x,  v, vtypeof( v), _, cb, r, cut); }
int libcdsb_list_find_map    (list_t* x, const  map_t* v, void* _, list_access_callback cb, bool r, bool cut) { return libcdsb_list_find(x,  v, vtypeof( v), _, cb, r, cut); }
int libcdsb_list_find_vset   (list_t* x, const  set_t* v, void* _, list_access_callback cb, bool r, bool cut) { return libcdsb_list_find(x,  v, vtypeof( v), _, cb, r, cut); }
int libcdsb_list_find_dict   (list_t* x, const dict_t* v, void* _, list_access_callback cb, bool r, bool cut) { return libcdsb_list_find(x,  v, vtypeof( v), _, cb, r, cut); }
int libcdsb_list_find_boolean(list_t* x,          bool v, void* _, list_access_callback cb, bool r, bool cut) { return libcdsb_list_find(x, &v, vtypeof(&v), _, cb, r, cut); }
int libcdsb_list_find_int8   (list_t* x,          s8_t v, void* _, list_access_callback cb, bool r, bool cut) { return libcdsb_list_find(x, &v, vtypeof(&v), _, cb, r, cut); }
int libcdsb_list_find_int16  (list_t* x,         s16_t v, void* _, list_access_callback cb, bool r, bool cut) { return libcdsb_list_find(x, &v, vtypeof(&v), _, cb, r, cut); }
int libcdsb_list_find_int32  (list_t* x,         s32_t v, void* _, list_access_callback cb, bool r, bool cut) { return libcdsb_list_find(x, &v, vtypeof(&v), _, cb, r, cut); }
int libcdsb_list_find_int64  (list_t* x,         s64_t v, void* _, list_access_callback cb, bool r, bool cut) { return libcdsb_list_find(x, &v, vtypeof(&v), _, cb, r, cut); }
int libcdsb_list_find_uint8  (list_t* x,          u8_t v, void* _, list_access_callback cb, bool r, bool cut) { return libcdsb_list_find(x, &v, vtypeof(&v), _, cb, r, cut); }
int libcdsb_list_find_uint16 (list_t* x,         u16_t v, void* _, list_access_callback cb, bool r, bool cut) { return libcdsb_list_find(x, &v, vtypeof(&v), _, cb, r, cut); }
int libcdsb_list_find_uint32 (list_t* x,         u32_t v, void* _, list_access_callback cb, bool r, bool cut) { return libcdsb_list_find(x, &v, vtypeof(&v), _, cb, r, cut); }
int libcdsb_list_find_uint64 (list_t* x,         u64_t v, void* _, list_access_callback cb, bool r, bool cut) { return libcdsb_list_find(x, &v, vtypeof(&v), _, cb, r, cut); }
int libcdsb_list_find_float  (list_t* x,          fl_t v, void* _, list_access_callback cb, bool r, bool cut) { return libcdsb_list_find(x, &v, vtypeof(&v), _, cb, r, cut); }
int libcdsb_list_find_double (list_t* x,         dbl_t v, void* _, list_access_callback cb, bool r, bool cut) { return libcdsb_list_find(x, &v, vtypeof(&v), _, cb, r, cut); }
int libcdsb_list_find_ldouble(list_t* x,        ldbl_t v, void* _, list_access_callback cb, bool r, bool cut) { return libcdsb_list_find(x, &v, vtypeof(&v), _, cb, r, cut); }

size_t libcdsb_list_count_pointer(const list_t* s, const   void* v) { return libcdsb_list_count((void*)s, &v, vtypeof(&v)); }
size_t libcdsb_list_count_cstring(const list_t* s, const   char* v) { return libcdsb_list_count((void*)s, &v, vtypeof(&v)); }
size_t libcdsb_list_count_string (const list_t* s, const  str_t* v) { return libcdsb_list_count((void*)s,  v, vtypeof( v)); }
size_t libcdsb_list_count_array  (const list_t* s, const  arr_t* v) { return libcdsb_list_count((void*)s,  v, vtypeof( v)); }
size_t libcdsb_list_count_list   (const list_t* s, const list_t* v) { return libcdsb_list_count((void*)s,  v, vtypeof( v)); }
size_t libcdsb_list_count_map    (const list_t* s, const  map_t* v) { return libcdsb_list_count((void*)s,  v, vtypeof( v)); }
size_t libcdsb_list_count_vset   (const list_t* s, const  set_t* v) { return libcdsb_list_count((void*)s,  v, vtypeof( v)); }
size_t libcdsb_list_count_dict   (const list_t* s, const dict_t* v) { return libcdsb_list_count((void*)s,  v, vtypeof( v)); }
size_t libcdsb_list_count_boolean(const list_t* s,          bool v) { return libcdsb_list_count((void*)s, &v, vtypeof(&v)); }
size_t libcdsb_list_count_int8   (const list_t* s,          s8_t v) { return libcdsb_list_count((void*)s, &v, vtypeof(&v)); }
size_t libcdsb_list_count_int16  (const list_t* s,         s16_t v) { return libcdsb_list_count((void*)s, &v, vtypeof(&v)); }
size_t libcdsb_list_count_int32  (const list_t* s,         s32_t v) { return libcdsb_list_count((void*)s, &v, vtypeof(&v)); }
size_t libcdsb_list_count_int64  (const list_t* s,         s64_t v) { return libcdsb_list_count((void*)s, &v, vtypeof(&v)); }
size_t libcdsb_list_count_uint8  (const list_t* s,          u8_t v) { return libcdsb_list_count((void*)s, &v, vtypeof(&v)); }
size_t libcdsb_list_count_uint16 (const list_t* s,         u16_t v) { return libcdsb_list_count((void*)s, &v, vtypeof(&v)); }
size_t libcdsb_list_count_uint32 (const list_t* s,         u32_t v) { return libcdsb_list_count((void*)s, &v, vtypeof(&v)); }
size_t libcdsb_list_count_uint64 (const list_t* s,         u64_t v) { return libcdsb_list_count((void*)s, &v, vtypeof(&v)); }
size_t libcdsb_list_count_float  (const list_t* s,          fl_t v) { return libcdsb_list_count((void*)s, &v, vtypeof(&v)); }
size_t libcdsb_list_count_double (const list_t* s,         dbl_t v) { return libcdsb_list_count((void*)s, &v, vtypeof(&v)); }
size_t libcdsb_list_count_ldouble(const list_t* s,        ldbl_t v) { return libcdsb_list_count((void*)s, &v, vtypeof(&v)); }

bool libcdsb_list_update_pointer(list_t* x, ssize_t i, const   void* v, int ins) { return libcdsb_list_update(x, i, &v, vtypeof(&v), ins);  }
bool libcdsb_list_update_cstring(list_t* x, ssize_t i, const   char* v, int ins) { return libcdsb_list_update(x, i, &v, vtypeof(&v), ins);  }
bool libcdsb_list_update_string (list_t* x, ssize_t i, const  str_t* v, int ins) { return libcdsb_list_update(x, i,  v, vtypeof( v), ins);  }
bool libcdsb_list_update_array  (list_t* x, ssize_t i, const  arr_t* v, int ins) { return libcdsb_list_update(x, i,  v, vtypeof( v), ins);  }
bool libcdsb_list_update_list   (list_t* x, ssize_t i, const list_t* v, int ins) { return libcdsb_list_update(x, i,  v, vtypeof( v), ins);  }
bool libcdsb_list_update_map    (list_t* x, ssize_t i, const  map_t* v, int ins) { return libcdsb_list_update(x, i,  v, vtypeof( v), ins);  }
bool libcdsb_list_update_vset   (list_t* x, ssize_t i, const  set_t* v, int ins) { return libcdsb_list_update(x, i,  v, vtypeof( v), ins);  }
bool libcdsb_list_update_dict   (list_t* x, ssize_t i, const dict_t* v, int ins) { return libcdsb_list_update(x, i,  v, vtypeof( v), ins);  }
bool libcdsb_list_update_boolean(list_t* x, ssize_t i,          bool v, int ins) { return libcdsb_list_update(x, i, &v, vtypeof(&v), ins);  }
bool libcdsb_list_update_int8   (list_t* x, ssize_t i,          s8_t v, int ins) { return libcdsb_list_update(x, i, &v, vtypeof(&v), ins);  }
bool libcdsb_list_update_int16  (list_t* x, ssize_t i,         s16_t v, int ins) { return libcdsb_list_update(x, i, &v, vtypeof(&v), ins);  }
bool libcdsb_list_update_int32  (list_t* x, ssize_t i,         s32_t v, int ins) { return libcdsb_list_update(x, i, &v, vtypeof(&v), ins);  }
bool libcdsb_list_update_int64  (list_t* x, ssize_t i,         s64_t v, int ins) { return libcdsb_list_update(x, i, &v, vtypeof(&v), ins);  }
bool libcdsb_list_update_uint8  (list_t* x, ssize_t i,          u8_t v, int ins) { return libcdsb_list_update(x, i, &v, vtypeof(&v), ins);  }
bool libcdsb_list_update_uint16 (list_t* x, ssize_t i,         u16_t v, int ins) { return libcdsb_list_update(x, i, &v, vtypeof(&v), ins);  }
bool libcdsb_list_update_uint32 (list_t* x, ssize_t i,         u32_t v, int ins) { return libcdsb_list_update(x, i, &v, vtypeof(&v), ins);  }
bool libcdsb_list_update_uint64 (list_t* x, ssize_t i,         u64_t v, int ins) { return libcdsb_list_update(x, i, &v, vtypeof(&v), ins);  }
bool libcdsb_list_update_float  (list_t* x, ssize_t i,          fl_t v, int ins) { return libcdsb_list_update(x, i, &v, vtypeof(&v), ins);  }
bool libcdsb_list_update_double (list_t* x, ssize_t i,         dbl_t v, int ins) { return libcdsb_list_update(x, i, &v, vtypeof(&v), ins);  }
bool libcdsb_list_update_ldouble(list_t* x, ssize_t i,        ldbl_t v, int ins) { return libcdsb_list_update(x, i, &v, vtypeof(&v), ins);  }
